## gcem 1.18.0

=== CMakeLists.txt ===
################################################################################
##
##   Copyright (C) 2016-2024 Keith O'Hara
##
##   This file is part of the GCE-Math C++ library.
##
##   Licensed under the Apache License, Version 2.0 (the "License");
##   you may not use this file except in compliance with the License.
##   You may obtain a copy of the License at
##
##       http://www.apache.org/licenses/LICENSE-2.0
##
##   Unless required by applicable law or agreed to in writing, software
##   distributed under the License is distributed on an "AS IS" BASIS,
##   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
##   See the License for the specific language governing permissions and
##   limitations under the License.
##
################################################################################

cmake_minimum_required(VERSION 3.1)
project(gcem)

set(GCEM_INCLUDE_DIR ${PROJECT_SOURCE_DIR}/include)

#

file(STRINGS "${GCEM_INCLUDE_DIR}/gcem_incl/gcem_options.hpp" gcem_version_defines
     REGEX "#define GCEM_VERSION_(MAJOR|MINOR|PATCH)")

foreach(ver ${gcem_version_defines})
    if(ver MATCHES "#define GCEM_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
        set(GCEM_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()

set(${PROJECT_NAME}_VERSION
    ${GCEM_VERSION_MAJOR}.${GCEM_VERSION_MINOR}.${GCEM_VERSION_PATCH})
message(STATUS "GCE-Math version ${${PROJECT_NAME}_VERSION}")

#

if(NOT MSVC)
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
    
    if(COMPILER_SUPPORTS_CXX11)
        message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has C++11 support.")
    else()
        message(FATAL_ERROR "Unsupported compiler ${CMAKE_CXX_COMPILER} "
            "GCEM requires a C++11-compatible compiler.")
    endif()
endif()

# options. enable using cmake3 -DGCEM_BUILD_TESTS=ON

OPTION(GCEM_BUILD_TESTS "gcem test suite" OFF)

# install

add_library(gcem INTERFACE)
target_include_directories(gcem INTERFACE $<BUILD_INTERFACE:${GCEM_INCLUDE_DIR}>
                                          $<INSTALL_INTERFACE:include>)

if(GCEM_BUILD_TESTS)
    add_subdirectory(tests)
endif()

#

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

install(
    TARGETS gcem
    EXPORT ${PROJECT_NAME}-targets
)

export(EXPORT ${PROJECT_NAME}-targets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")

install(DIRECTORY ${GCEM_INCLUDE_DIR}/
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

#

set(GCEM_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE STRING "install path for gcemConfig.cmake")

configure_package_config_file(cmake_files/${PROJECT_NAME}Config.cmake.in
                              "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
                              INSTALL_DESTINATION ${GCEM_CMAKECONFIG_INSTALL_DIR})

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
                                 VERSION ${${PROJECT_NAME}_VERSION}
                                 COMPATIBILITY SameMajorVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
        DESTINATION ${GCEM_CMAKECONFIG_INSTALL_DIR})

install(EXPORT ${PROJECT_NAME}-targets
        FILE ${PROJECT_NAME}Targets.cmake
        DESTINATION ${GCEM_CMAKECONFIG_INSTALL_DIR})

=== tests/CMakeLists.txt ===
################################################################################
##
##   Copyright (C) 2016-2024 Keith O'Hara
##
##   This file is part of the GCE-Math C++ library.
##
##   Licensed under the Apache License, Version 2.0 (the "License");
##   you may not use this file except in compliance with the License.
##   You may obtain a copy of the License at
##
##       http://www.apache.org/licenses/LICENSE-2.0
##
##   Unless required by applicable law or agreed to in writing, software
##   distributed under the License is distributed on an "AS IS" BASIS,
##   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
##   See the License for the specific language governing permissions and
##   limitations under the License.
##
################################################################################

cmake_minimum_required(VERSION 3.1)

if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    project(gcem-test)

    find_package(gcem REQUIRED CONFIG)
    set(GCEM_INCLUDE_DIR ${gcem_INCLUDE_DIRS})
endif ()

message(STATUS "Forcing tests build type to Release")
set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)

#

if(NOT MSVC)
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
    
    if(COMPILER_SUPPORTS_CXX11)
        if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -g -O0 -Wall -Wextra --coverage -fno-inline -fno-inline-small-functions -fno-default-inline")
        else()
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -g -O0 -Wall -Wextra --coverage -fno-inline")
        endif()
    else()
        message(FATAL_ERROR "Unsupported compiler ${CMAKE_CXX_COMPILER} "
            "GCEM requires a C++11-compatible compiler.")
    endif()
endif()

if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc /MP /bigobj")
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
endif()

#

file(GLOB GCEM_TESTS_SOURCES **.cpp **.c)
set( GCEM_TESTS ${GCEM_TESTS_SOURCES})

set(GCEM_TESTS_EX "")

foreach( file_ ${GCEM_TESTS} )
    get_filename_component(filename ${file_} NAME)
    string( REPLACE ".cpp" ".test" testname ${filename} )

    add_executable( ${testname} EXCLUDE_FROM_ALL ${filename} )
    target_link_libraries( ${testname} gcem )
    
    list(APPEND GCEM_TESTS_EX ${testname})
endforeach()

add_custom_target(gcem_tests DEPENDS ${GCEM_TESTS_EX})

#

=== tests/Makefile ===
# GCEM Test build

ifeq ($(CXX),)
	CXX = g++
endif

ifeq ($(GCEM_CXX_STD),)
	CXX_STD = -std=c++11
else
	CXX_STD=$(GCEM_CXX_STD)
endif

ifneq (,$(findstring clang,$(CXX)))
	OPT_FLAGS = -g -O0 -Wall -Wextra --coverage -fno-inline
else
	OPT_FLAGS = -g -O0 -Wall -Wextra --coverage -fno-inline -fno-inline-small-functions -fno-default-inline
endif

ifneq ($(TRAVIS_CLANG_BUILD),)
	OPT_FLAGS += -DTRAVIS_CLANG_CXX
endif

# source directories
SDIR = .
HEADER_DIR = $(SDIR)/../include

SOURCES_TESTS= $(wildcard $(SDIR)/*.cpp)
OBJECTS_TESTS= $(SOURCES_TESTS:.cpp=.test)

all: $(OBJECTS_TESTS)

$(SDIR)/%.test: $(SDIR)/%.cpp
	$(CXX) $(CXX_STD) $(OPT_FLAGS) -I$(HEADER_DIR) $< -o $@ $(LIBS)

# cleanup
.PHONY: clean
clean:
	@rm -rf *.test *.gcov *.gcno *.gcda *.dSYM

# individual make calls

GCEM_MAKE_CALL= $(CXX) $(CXX_STD) $(OPT_FLAGS) -I$(HEADER_DIR) $@.cpp -o $@.test $(LIBS)

abs:
	$(GCEM_MAKE_CALL)

acos:
	$(GCEM_MAKE_CALL)

acosh:
	$(GCEM_MAKE_CALL)

asin:
	$(GCEM_MAKE_CALL)

asinh:
	$(GCEM_MAKE_CALL)

atan:
	$(GCEM_MAKE_CALL)

atan2:
	$(GCEM_MAKE_CALL)

atanh:
	$(GCEM_MAKE_CALL)

binomial_coef:
	$(GCEM_MAKE_CALL)

copysign:
	$(GCEM_MAKE_CALL)

cos:
	$(GCEM_MAKE_CALL)

cosh:
	$(GCEM_MAKE_CALL)

erf:
	$(GCEM_MAKE_CALL)

erf_inv:
	$(GCEM_MAKE_CALL)

exp:
	$(GCEM_MAKE_CALL)

expm1:
	$(GCEM_MAKE_CALL)

fabs:
	$(GCEM_MAKE_CALL)

fabsf:
	$(GCEM_MAKE_CALL)

fabsl:
	$(GCEM_MAKE_CALL)

factorial:
	$(GCEM_MAKE_CALL)

fmod:
	$(GCEM_MAKE_CALL)

gcd:
	$(GCEM_MAKE_CALL)

hypot:
	$(GCEM_MAKE_CALL)

incomplete_beta:
	$(GCEM_MAKE_CALL)

incomplete_beta_inv:
	$(GCEM_MAKE_CALL)

incomplete_gamma:
	$(GCEM_MAKE_CALL)

incomplete_gamma_inv:
	$(GCEM_MAKE_CALL)

inv_sqrt:
	$(GCEM_MAKE_CALL)

is_odd:
	$(GCEM_MAKE_CALL)

lcm:
	$(GCEM_MAKE_CALL)

lgamma:
	$(GCEM_MAKE_CALL)

log_binomial_coef:
	$(GCEM_MAKE_CALL)

log:
	$(GCEM_MAKE_CALL)

log1p:
	$(GCEM_MAKE_CALL)

log2:
	$(GCEM_MAKE_CALL)

log10:
	$(GCEM_MAKE_CALL)

other:
	$(GCEM_MAKE_CALL)

pow:
	$(GCEM_MAKE_CALL)

rounding:
	$(GCEM_MAKE_CALL)

signbit:
	$(GCEM_MAKE_CALL)

sin:
	$(GCEM_MAKE_CALL)

sinh:
	$(GCEM_MAKE_CALL)

sqrt:
	$(GCEM_MAKE_CALL)

tan:
	$(GCEM_MAKE_CALL)

tanh:
	$(GCEM_MAKE_CALL)

tgamma:
	$(GCEM_MAKE_CALL)

=== debian/changelog ===
gcem (1.18.0-2) unstable; urgency=medium

  * Remove redundant Priority stanza from debian/control
  * Configure with -DCMAKE_POLICY_VERSION_MINIMUM=3.5 to fix FTBFS
    with CMake 4.2 (Closes: #1125530)

 -- Fabian Greffrath <fabian@debian.org>  Tue, 20 Jan 2026 08:07:55 +0100

gcem (1.18.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1117715)

 -- Fabian Greffrath <fabian@debian.org>  Fri, 10 Oct 2025 08:26:44 +0200

=== debian/control ===
Source: gcem
Section: libs
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Fabian Greffrath <fabian@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Standards-Version: 4.7.2
Homepage: https://github.com/kthohr/gcem
Vcs-Browser: https://salsa.debian.org/multimedia-team/gcem
Vcs-Git: https://salsa.debian.org/multimedia-team/gcem.git

Package: libgcem-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Description: C++ math library using generalized constant expressions
 GCE-Math (Generalized Constant Expression Math) is a templated C++ library
 enabling compile-time computation of mathematical functions.
 .
 Features:
 .
  * The library is written in C++11 constexpr format, and is C++11/14/17/20
    compatible.
  * Continued fraction expansions and series expansions are implemented using
    recursive templates.
  * The gcem:: syntax is identical to that of the C++ standard library (std::).
  * Tested and accurate to floating-point precision against the C++ standard
    library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_POLICY_VERSION_MINIMUM=3.5
